<?php
namespace Teknisa\DF\Modules\Saida\Controllers;

use Teknisa\DF\Modules\Saida\Services\Dfs74000CalculoReceitaBrutaSimplesNacionalService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;


class Dfs74000CalculoReceitaBrutaSimplesNacionalController extends \Teknisa\DF\Controllers\TeknisaCrud {
    protected $dataSourceName;

    public function __construct($crudService, ParameterBag $parameterBag, Dfs74000CalculoReceitaBrutaSimplesNacionalService $serviceCalculoReceitaBruta) {
        $this->serviceCalculoReceitaBruta = $serviceCalculoReceitaBruta;
         parent::__construct($crudService, $parameterBag);
    }


    public function buscaMesPosterior (DTO\Request\Row $request, DTO\Response $response){
        try{
            $row = $request->getRow();
            $mes = $this->serviceCalculoReceitaBruta->buscaMesPosterior($row);
            $response->addDataSet(new DataSet("result", $mes));
        } catch (\Exception $e){
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

    public function calculaReceitaBrutaMes (DTO\Request\Row $request, DTO\Response $response){
        try{
            $row = $request->getRow();
            $valorReceitaMes = $this->serviceCalculoReceitaBruta->calculaReceitaBrutaMes($row);
            $response->addDataSet(new DataSet("receitaBruta", $valorReceitaMes));
        } catch (\Exception $e){
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

    public function bloquerMesReceita (DTO\Request\Row $request, DTO\Response $response){
        try{
            $row = $request->getRow();
            $valorReceitaMes = $this->serviceCalculoReceitaBruta->bloqueaMesReceita($row);
            $response->addDataSet(new DataSet("receitaBruta", $valorReceitaMes));
        } catch (\Exception $e){
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

    public function buscaNotasFiscaisMes (DTO\Request\Row $request, DTO\Response $response){
        try{
            $row = $request->getRow();
            $notasFiscais = $this->serviceCalculoReceitaBruta->buscaNotasFiscaisMes($row);
            $response->addDataSet(new DataSet("notasFiscais", $notasFiscais));
        } catch (\Exception $e){
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

    public function saveReceitaBruta (DTO\Request\Row $request, DTO\Response $response){
        try{
            $row = $request->getRow();
            $ararayMes [] = $row['mesAtual'];
            $dataSetMes = new DataSet('receitabruta', $ararayMes);
            $requestMes = new DTO\Request\DataSet($dataSetMes, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            $rows = $this->crudService->getRowsToSave($requestMes, 'receitabruta');
            $this->serviceCalculoReceitaBruta->saveMesReceitaBruta($rows, $row['mesPosterior']);
        } catch (\Exception $e){
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

    public function deleteMesReceita (DTO\Request\Row $request, DTO\Response $response){
        try{
            $row = $request->getRow();
            $this->serviceCalculoReceitaBruta->deleteMesReceita($row);
        } catch (\Exception $e){
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
    public function validacoesSave (DTO\Request\Row $request, DTO\Response $response){
        try{
            $row = $request->getRow();
            $mes = $this->serviceCalculoReceitaBruta->validacoesSave($row);
            $response->addDataSet(new DataSet("result", $mes));
        } catch (\Exception $e){
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

}

?>